typedef struct FSOUND_SAMPLE    FSOUND_SAMPLE;
typedef struct FSOUND_STREAM    FSOUND_STREAM;
typedef struct FSOUND_DSPUNIT   FSOUND_DSPUNIT;
typedef struct FMUSIC_MODULE    FMUSIC_MODULE;

typedef void *      (__stdcall *FSOUND_DSPCALLBACK)    (void *originalbuffer, void *newbuffer, int length, int param);
typedef signed char (__stdcall *FSOUND_STREAMCALLBACK) (FSOUND_STREAM *,void *,int,int);
typedef void        (__stdcall *FMUSIC_CALLBACK)       (FMUSIC_MODULE *,unsigned char);

typedef unsigned int(__stdcall *FSOUND_OPENCALLBACK)   (const char *);
typedef void        (__stdcall *FSOUND_CLOSECALLBACK)  (unsigned int);
typedef int         (__stdcall *FSOUND_READCALLBACK)   (void *,int,unsigned int);
typedef int         (__stdcall *FSOUND_SEEKCALLBACK)   (unsigned int,int,signed char);
typedef int         (__stdcall *FSOUND_TELLCALLBACK)   (unsigned int);

typedef void *      (__stdcall *FSOUND_ALLOCCALLBACK)  (unsigned int);
typedef void *      (__stdcall *FSOUND_REALLOCCALLBACK)(void *,unsigned int);
typedef void        (__stdcall *FSOUND_FREECALLBACK)   (void *);

typedef struct _FSOUND_REVERB_PROPERTIES {                                   
    unsigned int Environment;
    float        EnvSize;
    float        EnvDiffusion;
    int          Room;
    int          RoomHF;
    int          RoomLF;
    float        DecayTime;
    float        DecayHFRatio;
    float        DecayLFRatio;
    int          Reflections;
    float        ReflectionsDelay;
    float        ReflectionsPan[3];
    int          Reverb;
    float        ReverbDelay;
    float        ReverbPan[3];
    float        EchoTime;
    float        EchoDepth;
    float        ModulationTime;
    float        ModulationDepth;
    float        AirAbsorptionHF;
    float        HFReference;
    float        LFReference;
    float        RoomRolloffFactor;
    float        Diffusion;
    float        Density;
    unsigned int Flags;
} FSOUND_REVERB_PROPERTIES;

typedef struct _FSOUND_REVERB_CHANNELPROPERTIES {                                   
    int    Direct;
    int    DirectHF;
    int    Room;
    int    RoomHF;
    int    Obstruction;
    float  ObstructionLFRatio;
    int    Occlusion;
    float  OcclusionLFRatio;
    float  OcclusionRoomRatio;
    float  OcclusionDirectRatio;
    int    Exclusion;
    float  ExclusionLFRatio;
    int    OutsideVolumeHF;
    float  DopplerFactor;
    float  RolloffFactor;
    float  RoomRolloffFactor;
    float  AirAbsorptionFactor;
    int    Flags;
} FSOUND_REVERB_CHANNELPROPERTIES;

enum FSOUND_MIXERTYPES
{
    FSOUND_MIXER_AUTODETECT,
    FSOUND_MIXER_BLENDMODE,
    FSOUND_MIXER_MMXP5,
    FSOUND_MIXER_MMXP6,

    FSOUND_MIXER_QUALITY_AUTODETECT,
    FSOUND_MIXER_QUALITY_FPU,
    FSOUND_MIXER_QUALITY_MMXP5,
    FSOUND_MIXER_QUALITY_MMXP6,

    FSOUND_MIXER_MONO,
    FSOUND_MIXER_QUALITY_MONO,

    FSOUND_MIXER_MAX
};

typedef signed char (__stdcall *FMUSIC_FreeSong)(FMUSIC_MODULE *);
typedef FMUSIC_MODULE * (__stdcall *FMUSIC_LoadSong)(const char *);
typedef FMUSIC_MODULE * (__stdcall *FMUSIC_LoadSongEx)(const char *,int,int,unsigned int,int *,int);
typedef signed char (__stdcall *FMUSIC_OptimizeChannels)(FMUSIC_MODULE *,int maxchannels,int);
typedef signed char (__stdcall *FMUSIC_PlaySong)(FMUSIC_MODULE *);
typedef signed char (__stdcall *FMUSIC_SetInstCallback)(FMUSIC_MODULE *,FMUSIC_CALLBACK,int);
typedef signed char (__stdcall *FMUSIC_SetLooping)(FMUSIC_MODULE *,signed char);
typedef signed char (__stdcall *FMUSIC_SetMasterSpeed)(FMUSIC_MODULE *,float);
typedef signed char (__stdcall *FMUSIC_SetMasterVolume)(FMUSIC_MODULE *,int);
typedef signed char (__stdcall *FMUSIC_SetOrder)(FMUSIC_MODULE *,int);
typedef signed char (__stdcall *FMUSIC_SetOrderCallback)(FMUSIC_MODULE *,FMUSIC_CALLBACK,int);
typedef signed char (__stdcall *FMUSIC_SetPanSeperation)(FMUSIC_MODULE *,float);
typedef signed char (__stdcall *FMUSIC_SetPaused)(FMUSIC_MODULE *,signed char);
typedef signed char (__stdcall *FMUSIC_SetReverb)(signed char);
typedef signed char (__stdcall *FMUSIC_SetRowCallback)(FMUSIC_MODULE *,FMUSIC_CALLBACK,int);
typedef signed char (__stdcall *FMUSIC_SetUserData)(FMUSIC_MODULE *,unsigned int);
typedef signed char (__stdcall *FMUSIC_SetZxxCallback)(FMUSIC_MODULE *,FMUSIC_CALLBACK);
typedef void (__stdcall *FMUSIC_StopAllSongs)();
typedef signed char (__stdcall *FMUSIC_StopSong)(FMUSIC_MODULE *);
typedef int (__stdcall *FMUSIC_GetBPM)(FMUSIC_MODULE *);
typedef int (__stdcall *FMUSIC_GetGlobalVolume)(FMUSIC_MODULE *);
typedef int (__stdcall *FMUSIC_GetMasterVolume)(FMUSIC_MODULE *);
typedef char * (__stdcall *FMUSIC_GetName)(FMUSIC_MODULE *);
typedef int (__stdcall *FMUSIC_GetNumChannels)(FMUSIC_MODULE *);
typedef int (__stdcall *FMUSIC_GetNumInstruments)(FMUSIC_MODULE *);
typedef int (__stdcall *FMUSIC_GetNumOrders)(FMUSIC_MODULE *);
typedef int (__stdcall *FMUSIC_GetNumPatterns)(FMUSIC_MODULE *);
typedef int (__stdcall *FMUSIC_GetNumSamples)(FMUSIC_MODULE *);
typedef int (__stdcall *FMUSIC_GetOrder)(FMUSIC_MODULE *);
typedef int (__stdcall *FMUSIC_GetPattern)(FMUSIC_MODULE *);
typedef int (__stdcall *FMUSIC_GetPatternLength)(FMUSIC_MODULE *,int);
typedef signed char (__stdcall *FMUSIC_GetPaused)(FMUSIC_MODULE *);
typedef int (__stdcall *FMUSIC_GetRow)(FMUSIC_MODULE *);
typedef FSOUND_SAMPLE * (__stdcall *FMUSIC_GetSample)(FMUSIC_MODULE *,int);
typedef int (__stdcall *FMUSIC_GetSpeed)(FMUSIC_MODULE *);
typedef int (__stdcall *FMUSIC_GetTime)(FMUSIC_MODULE *);
typedef int (__stdcall *FMUSIC_GetType)(FMUSIC_MODULE *);
typedef unsigned int (__stdcall *FMUSIC_GetUserData)(FMUSIC_MODULE *);
typedef signed char (__stdcall *FMUSIC_IsFinished)(FMUSIC_MODULE *);
typedef signed char (__stdcall *FMUSIC_IsPlaying)(FMUSIC_MODULE *);
typedef signed char (__stdcall *FSOUND_Init)(int,int,unsigned int);
typedef void (__stdcall *FSOUND_Close)();
typedef signed char (__stdcall *FSOUND_SetBufferSize)(int);
typedef signed char (__stdcall *FSOUND_SetDriver)(int);
typedef signed char (__stdcall *FSOUND_SetHWND)(void *);
typedef signed char (__stdcall *FSOUND_SetMaxHardwareChannels)(int);
typedef signed char (__stdcall *FSOUND_SetMinHardwareChannels)(int);
typedef signed char (__stdcall *FSOUND_SetMixer)(int);
typedef signed char (__stdcall *FSOUND_SetOutput)(int);
typedef int (__stdcall *FSOUND_GetChannelsPlaying)();
typedef int (__stdcall *FSOUND_GetMaxSamples)();
typedef int (__stdcall *FSOUND_GetMaxChannels)();
typedef int (__stdcall *FSOUND_GetNumDrivers)();
typedef int (__stdcall *FSOUND_GetOutput)();
typedef void * (__stdcall *FSOUND_GetOutputHandle)();
typedef int (__stdcall *FSOUND_GetOutputRate)();
typedef int (__stdcall *FSOUND_GetDriver)();
typedef signed char * (__stdcall *FSOUND_GetDriverName)(int);
typedef FSOUND_SAMPLE * (__stdcall *FSOUND_Sample_Alloc)(int,int,unsigned int,int,int,int,int);
typedef void (__stdcall *FSOUND_Sample_Free)(FSOUND_SAMPLE *);
typedef FSOUND_SAMPLE * (__stdcall *FSOUND_Sample_Get)(int);
typedef signed char (__stdcall *FSOUND_Sample_GetDefaults)(FSOUND_SAMPLE *,int *,int *,int *,int *);
typedef unsigned int (__stdcall *FSOUND_Sample_GetLength)(FSOUND_SAMPLE *);
typedef signed char (__stdcall *FSOUND_Sample_GetLoopPoints)(FSOUND_SAMPLE *,int *,int *);
typedef unsigned int (__stdcall *FSOUND_Sample_GetMode)(FSOUND_SAMPLE *);
typedef char * (__stdcall *FSOUND_Sample_GetName)(FSOUND_SAMPLE *);
typedef FSOUND_SAMPLE * (__stdcall *FSOUND_Sample_Load)(int,const char *,unsigned int,int);
typedef signed char (__stdcall *FSOUND_Sample_Lock)(FSOUND_SAMPLE *,int,int,void **,void **,unsigned int *,unsigned int *);
typedef signed char (__stdcall *FSOUND_Sample_SetDefaults)(FSOUND_SAMPLE *,int,int,int,int);
typedef signed char (__stdcall *FSOUND_Sample_SetMaxPlaybacks)(FSOUND_SAMPLE *,int);
typedef signed char (__stdcall *FSOUND_Sample_SetMinMaxDistance)(FSOUND_SAMPLE *,float,float);
typedef signed char (__stdcall *FSOUND_Sample_SetMode)(FSOUND_SAMPLE *sptr,unsigned int);
typedef signed char (__stdcall *FSOUND_Sample_SetLoopPoints)(FSOUND_SAMPLE *,int,int);
typedef signed char (__stdcall *FSOUND_Sample_Unlock)(FSOUND_SAMPLE *,void *,void *,unsigned int,unsigned int);
typedef signed char (__stdcall *FSOUND_Sample_Upload)(FSOUND_SAMPLE *,void *,unsigned int);
typedef int (__stdcall *FSOUND_PlaySound)(int,FSOUND_SAMPLE *);
typedef int (__stdcall *FSOUND_PlaySoundEx)(int,FSOUND_SAMPLE *,FSOUND_DSPUNIT *,signed char);
typedef signed char (__stdcall *FSOUND_StopSound)(int);
typedef signed char (__stdcall *FSOUND_SetFrequency)(int,int);

typedef signed char (__stdcall *FSOUND_SetLoopMode)(int,unsigned int);
typedef signed char (__stdcall *FSOUND_SetMute)(int,signed char);
typedef signed char (__stdcall *FSOUND_SetPan)(int,int);
typedef signed char (__stdcall *FSOUND_SetPaused)(int,signed char);
typedef signed char (__stdcall *FSOUND_SetPriority)(int,int);
typedef signed char (__stdcall *FSOUND_SetReserved)(int,signed char);
typedef signed char (__stdcall *FSOUND_SetSurround)(int,signed char);
typedef signed char (__stdcall *FSOUND_SetVolume)(int,int);
typedef signed char (__stdcall *FSOUND_SetVolumeAbsolute)(int,int);
typedef int (__stdcall *FSOUND_GetVolume)(int);
typedef signed char (__stdcall *FSOUND_SetCurrentPosition)(int,unsigned int);
typedef unsigned int (__stdcall *FSOUND_GetCurrentPosition)(int);
typedef FSOUND_SAMPLE * (__stdcall *FSOUND_GetCurrentSample)(int);
typedef signed char (__stdcall *FSOUND_GetCurrentLevels)(int,float *,float *);
typedef int (__stdcall *FSOUND_GetFrequency)(int);
typedef unsigned int (__stdcall *FSOUND_GetLoopMode)(int);
typedef int (__stdcall *FSOUND_GetMixer)();
typedef signed char (__stdcall *FSOUND_GetMute)(int);
typedef int (__stdcall *FSOUND_GetPan)(int);
typedef signed char (__stdcall *FSOUND_GetPaused)(int);
typedef int (__stdcall *FSOUND_GetPriority)(int);
typedef signed char (__stdcall *FSOUND_GetReserved)(int);
typedef signed char (__stdcall *FSOUND_GetSurround)(int);
typedef signed char (__stdcall *FSOUND_IsPlaying)(int);
typedef void (__stdcall *FSOUND_3D_Listener_GetAttributes)(float *,float *,float *,float *,float *,float *,float *,float *);
typedef void (__stdcall *FSOUND_3D_Listener_SetAttributes)(float *,float *,float,float,float,float,float,float);
typedef signed char (__stdcall *FSOUND_3D_GetAttributes)(int,float *,float *);
typedef void (__stdcall *FSOUND_3D_Listener_SetCurrent)(int,int);
typedef void (__stdcall *FSOUND_3D_SetDistanceFactor)(float);
typedef void (__stdcall *FSOUND_3D_SetDopplerFactor)(float);
typedef void (__stdcall *FSOUND_3D_SetRolloffFactor)(float);
typedef signed char (__stdcall *FSOUND_3D_SetAttributes)(int,float *,float *);
typedef void (__stdcall *FSOUND_Update)();
typedef int (__stdcall *FSOUND_Stream_AddSynchPoint)(FSOUND_STREAM *,unsigned int,int);
typedef signed char (__stdcall *FSOUND_Stream_Close)(FSOUND_STREAM *);
typedef FSOUND_STREAM * (__stdcall *FSOUND_Stream_Create)(FSOUND_STREAMCALLBACK,int,unsigned int,int,int);
typedef FSOUND_DSPUNIT *(__stdcall *FSOUND_Stream_CreateDSP)(FSOUND_STREAM *,FSOUND_DSPCALLBACK,int,int);
typedef signed char (__stdcall *FSOUND_Stream_DeleteSynchPoint)(FSOUND_STREAM *,int);
typedef int (__stdcall *FSOUND_Stream_GetLength)(FSOUND_STREAM *);
typedef int (__stdcall *FSOUND_Stream_GetLengthMs)(FSOUND_STREAM *);
typedef int (__stdcall *FSOUND_Stream_GetNumSubStreams)(FSOUND_STREAM *);
typedef int (__stdcall *FSOUND_Stream_GetNumSynchPoints)(FSOUND_STREAM *);
typedef int (__stdcall *FSOUND_Stream_GetOpenState)(FSOUND_STREAM *);
typedef unsigned int (__stdcall *FSOUND_Stream_GetPosition)(FSOUND_STREAM *);
typedef FSOUND_SAMPLE * (__stdcall *FSOUND_Stream_GetSample)(FSOUND_STREAM *);
typedef int (__stdcall *FSOUND_Stream_GetTime)(FSOUND_STREAM *);
typedef FSOUND_STREAM * (__stdcall *FSOUND_Stream_Open)(const char *,int,unsigned int,int);
typedef int (__stdcall *FSOUND_Stream_Play)(int,FSOUND_STREAM *);
typedef int (__stdcall *FSOUND_Stream_PlayEx)(int,FSOUND_STREAM *,FSOUND_DSPUNIT *, signed char startpaused);
typedef signed char (__stdcall *FSOUND_Stream_SetBufferSize)(int ms);
typedef signed char (__stdcall *FSOUND_Stream_SetEndCallback)(FSOUND_STREAM *,FSOUND_STREAMCALLBACK,int);
typedef signed char (__stdcall *FSOUND_Stream_SetLoopPoints)(FSOUND_STREAM *,unsigned int,unsigned int);
typedef signed char (__stdcall *FSOUND_Stream_SetPosition)(FSOUND_STREAM *,unsigned int);
typedef signed char (__stdcall *FSOUND_Stream_SetSubStream)(FSOUND_STREAM *,int);
typedef signed char (__stdcall *FSOUND_Stream_SetSynchCallback)(FSOUND_STREAM *,FSOUND_STREAMCALLBACK,int);
typedef signed char (__stdcall *FSOUND_Stream_SetTime)(FSOUND_STREAM *,int);
typedef signed char (__stdcall *FSOUND_Stream_Stop)(FSOUND_STREAM *);
typedef signed char (__stdcall *FSOUND_CD_Eject)(char);
typedef int (__stdcall *FSOUND_CD_GetNumTracks)(char);
typedef signed char (__stdcall *FSOUND_CD_GetPaused)(char);
typedef int (__stdcall *FSOUND_CD_GetTrack)(char);
typedef int (__stdcall *FSOUND_CD_GetTrackLength)(char,int); 
typedef int (__stdcall *FSOUND_CD_GetTrackTime)(char);
typedef signed char (__stdcall *FSOUND_CD_Play)(char,int);
typedef signed char (__stdcall *FSOUND_CD_SetPaused)(char,signed char);
typedef void (__stdcall *FSOUND_CD_SetPlayMode)(char,signed char);
typedef signed char (__stdcall *FSOUND_CD_SetVolume)(char,int);
typedef signed char (__stdcall *FSOUND_CD_Stop)(char);
typedef void (__stdcall *FSOUND_DSP_ClearMixBuffer)();
typedef FSOUND_DSPUNIT *(__stdcall *FSOUND_DSP_Create)(FSOUND_DSPCALLBACK,int,int);
typedef void (__stdcall *FSOUND_DSP_Free)(FSOUND_DSPUNIT *);
typedef void (__stdcall *FSOUND_DSP_SetActive)(FSOUND_DSPUNIT *,signed char);
typedef signed char (__stdcall *FSOUND_DSP_GetActive)(FSOUND_DSPUNIT *);
typedef int (__stdcall *FSOUND_DSP_GetBufferLength)();
typedef int (__stdcall *FSOUND_DSP_GetBufferLengthTotal)();
typedef void (__stdcall *FSOUND_DSP_SetPriority)(FSOUND_DSPUNIT *,int);
typedef int (__stdcall *FSOUND_DSP_GetPriority)(FSOUND_DSPUNIT *);
typedef FSOUND_DSPUNIT *(__stdcall *FSOUND_DSP_GetClearUnit)();
typedef FSOUND_DSPUNIT *(__stdcall *FSOUND_DSP_GetClipAndCopyUnit)();
typedef FSOUND_DSPUNIT *(__stdcall *FSOUND_DSP_GetMusicUnit)();
typedef FSOUND_DSPUNIT *(__stdcall *FSOUND_DSP_GetSFXUnit)();
typedef FSOUND_DSPUNIT *(__stdcall *FSOUND_DSP_GetFFTUnit)();
typedef float * (__stdcall *FSOUND_DSP_GetSpectrum)();
typedef signed char (__stdcall *FSOUND_DSP_MixBuffers)(void *,void *,int,int,int,int,unsigned int);
typedef signed char (__stdcall *FSOUND_FX_Disable)(int);    
typedef int (__stdcall *FSOUND_FX_Enable)(int,unsigned int);
typedef signed char (__stdcall *FSOUND_FX_SetChorus)(int,float,float,float,float,int,float,int);
typedef signed char (__stdcall *FSOUND_FX_SetCompressor)(int,float,float,float,float,float,float);
typedef signed char (__stdcall *FSOUND_FX_SetDistortion)(int,float,float,float,float,float);
typedef signed char (__stdcall *FSOUND_FX_SetEcho)(int,float,float,float,float,int);
typedef signed char (__stdcall *FSOUND_FX_SetFlanger)(int,float,float,float,float,int,float,int);
typedef signed char (__stdcall *FSOUND_FX_SetGargle)(int,int,int);
typedef signed char (__stdcall *FSOUND_FX_SetI3DL2Reverb)(int,int,int,float,float,float,int,float,int,float,float,float,float);
typedef signed char (__stdcall *FSOUND_FX_SetParamEQ)(int,float,float,float);
typedef signed char (__stdcall *FSOUND_FX_SetWavesReverb)(int,float,float,float,float);  
typedef int (__stdcall *FSOUND_Record_GetDriver)();
typedef signed char * (__stdcall *FSOUND_Record_GetDriverName)(int);
typedef int (__stdcall *FSOUND_Record_GetNumDrivers)();
typedef int (__stdcall *FSOUND_Record_GetPosition)();  
typedef signed char (__stdcall *FSOUND_Record_SetDriver)(int);
typedef signed char (__stdcall *FSOUND_Record_StartSample)(FSOUND_SAMPLE *,signed char);
typedef signed char (__stdcall *FSOUND_Record_Stop)();
typedef signed char (__stdcall *FSOUND_Reverb_SetProperties)(FSOUND_REVERB_PROPERTIES *);
typedef signed char (__stdcall *FSOUND_Reverb_GetProperties)(FSOUND_REVERB_PROPERTIES *);
typedef signed char (__stdcall *FSOUND_Reverb_SetChannelProperties)(int,FSOUND_REVERB_CHANNELPROPERTIES *);
typedef signed char (__stdcall *FSOUND_Reverb_GetChannelProperties)(int,FSOUND_REVERB_CHANNELPROPERTIES *);
typedef void (__stdcall *FSOUND_File_SetCallbacks)(FSOUND_OPENCALLBACK,FSOUND_CLOSECALLBACK,FSOUND_READCALLBACK,FSOUND_SEEKCALLBACK,FSOUND_TELLCALLBACK);
typedef float (__stdcall *FSOUND_GetCPUUsage)();
typedef signed char (__stdcall *FSOUND_GetDriverCaps)(int,unsigned int *);
typedef int (__stdcall *FSOUND_GetError)();
typedef void (__stdcall *FSOUND_GetMemoryStats)(unsigned int *,unsigned int *);
typedef int (__stdcall *FSOUND_GetNumHardwareChannels)();
typedef int (__stdcall *FSOUND_GetSFXMasterVolume)();
typedef float (__stdcall *FSOUND_GetVersion)();
typedef signed char (__stdcall *FSOUND_SetMemorySystem)(void *,int,FSOUND_ALLOCCALLBACK,FSOUND_REALLOCCALLBACK,FSOUND_FREECALLBACK);
typedef void (__stdcall *FSOUND_SetPanSeperation)(float);
typedef void (__stdcall *FSOUND_SetSFXMasterVolume)(int);
typedef void (__stdcall *FSOUND_SetSpeakerMode)(unsigned int);

//typedef void (__stdcall *FSOUND_Stream_Net_GetBufferProperties)();
//typedef void (__stdcall *FSOUND_Stream_Net_GetInfo)();
//typedef void (__stdcall *FSOUND_Stream_Net_GetLastServerStatus)();
//typedef void (__stdcall *FSOUND_Stream_Net_SetBufferProperties)();
//typedef void (__stdcall *FSOUND_Stream_Net_SetProxy)();


typedef struct {
	HMODULE module;

	FMUSIC_FreeSong						FMUSIC_FreeSong;
	FMUSIC_LoadSong						FMUSIC_LoadSong;
	FMUSIC_LoadSongEx						FMUSIC_LoadSongEx;
	FMUSIC_OptimizeChannels					FMUSIC_OptimizeChannels;
	FMUSIC_PlaySong						FMUSIC_PlaySong;
	FMUSIC_SetInstCallback					FMUSIC_SetInstCallback;
	FMUSIC_SetLooping						FMUSIC_SetLooping;
	FMUSIC_SetMasterSpeed					FMUSIC_SetMasterSpeed;
	FMUSIC_SetMasterVolume					FMUSIC_SetMasterVolume;
	FMUSIC_SetOrder						FMUSIC_SetOrder;
	FMUSIC_SetOrderCallback					FMUSIC_SetOrderCallback;
	FMUSIC_SetPanSeperation					FMUSIC_SetPanSeperation;
	FMUSIC_SetPaused						FMUSIC_SetPaused;
	FMUSIC_SetReverb						FMUSIC_SetReverb;
	FMUSIC_SetRowCallback					FMUSIC_SetRowCallback;
	FMUSIC_SetUserData					FMUSIC_SetUserData;
	FMUSIC_SetZxxCallback					FMUSIC_SetZxxCallback;
	FMUSIC_StopAllSongs					FMUSIC_StopAllSongs;
	FMUSIC_StopSong						FMUSIC_StopSong;
	FMUSIC_GetBPM						FMUSIC_GetBPM;
	FMUSIC_GetGlobalVolume					FMUSIC_GetGlobalVolume;
	FMUSIC_GetMasterVolume					FMUSIC_GetMasterVolume;
	FMUSIC_GetName						FMUSIC_GetName;
	FMUSIC_GetNumChannels					FMUSIC_GetNumChannels;
	FMUSIC_GetNumInstruments				FMUSIC_GetNumInstruments;
	FMUSIC_GetNumOrders					FMUSIC_GetNumOrders;
	FMUSIC_GetNumPatterns					FMUSIC_GetNumPatterns;
	FMUSIC_GetNumSamples					FMUSIC_GetNumSamples;
	FMUSIC_GetOrder						FMUSIC_GetOrder;
	FMUSIC_GetPattern						FMUSIC_GetPattern;
	FMUSIC_GetPatternLength					FMUSIC_GetPatternLength;
	FMUSIC_GetPaused						FMUSIC_GetPaused;
	FMUSIC_GetRow						FMUSIC_GetRow;
	FMUSIC_GetSample						FMUSIC_GetSample;
	FMUSIC_GetSpeed						FMUSIC_GetSpeed;
	FMUSIC_GetTime						FMUSIC_GetTime;
	FMUSIC_GetType						FMUSIC_GetType;
	FMUSIC_GetUserData					FMUSIC_GetUserData;
	FMUSIC_IsFinished						FMUSIC_IsFinished;
	FMUSIC_IsPlaying						FMUSIC_IsPlaying;
	FSOUND_Init							FSOUND_Init;
	FSOUND_Close						FSOUND_Close;
	FSOUND_SetBufferSize					FSOUND_SetBufferSize;
	FSOUND_SetDriver						FSOUND_SetDriver;
	FSOUND_SetHWND						FSOUND_SetHWND;
	FSOUND_SetMaxHardwareChannels				FSOUND_SetMaxHardwareChannels;
	FSOUND_SetMinHardwareChannels				FSOUND_SetMinHardwareChannels;
	FSOUND_SetMixer						FSOUND_SetMixer;
	FSOUND_SetOutput						FSOUND_SetOutput;

	FSOUND_GetChannelsPlaying				FSOUND_GetChannelsPlaying;
	FSOUND_GetMaxSamples					FSOUND_GetMaxSamples;
	FSOUND_GetMaxChannels					FSOUND_GetMaxChannels;
	FSOUND_GetNumDrivers					FSOUND_GetNumDrivers;
	FSOUND_GetOutput						FSOUND_GetOutput;
	FSOUND_GetOutputHandle					FSOUND_GetOutputHandle;
	FSOUND_GetOutputRate					FSOUND_GetOutputRate;
	FSOUND_GetDriver						FSOUND_GetDriver;
	FSOUND_GetDriverName					FSOUND_GetDriverName;
	FSOUND_Sample_Alloc					FSOUND_Sample_Alloc;
	FSOUND_Sample_Free					FSOUND_Sample_Free;
	FSOUND_Sample_Get						FSOUND_Sample_Get;
	FSOUND_Sample_GetDefaults				FSOUND_Sample_GetDefaults;
	FSOUND_Sample_GetLength					FSOUND_Sample_GetLength;
	FSOUND_Sample_GetLoopPoints				FSOUND_Sample_GetLoopPoints;
	FSOUND_Sample_GetMode					FSOUND_Sample_GetMode;
	FSOUND_Sample_GetName					FSOUND_Sample_GetName;
	FSOUND_Sample_Load					FSOUND_Sample_Load;
	FSOUND_Sample_Lock					FSOUND_Sample_Lock;
	FSOUND_Sample_SetDefaults				FSOUND_Sample_SetDefaults;
	FSOUND_Sample_SetMaxPlaybacks				FSOUND_Sample_SetMaxPlaybacks;
	FSOUND_Sample_SetMinMaxDistance			FSOUND_Sample_SetMinMaxDistance;
	FSOUND_Sample_SetMode					FSOUND_Sample_SetMode;
	FSOUND_Sample_SetLoopPoints				FSOUND_Sample_SetLoopPoints;
	FSOUND_Sample_Unlock					FSOUND_Sample_Unlock;
	FSOUND_Sample_Upload					FSOUND_Sample_Upload;
	FSOUND_PlaySound						FSOUND_PlaySound;
	FSOUND_PlaySoundEx					FSOUND_PlaySoundEx;
	FSOUND_StopSound						FSOUND_StopSound;
	FSOUND_SetFrequency					FSOUND_SetFrequency;

	FSOUND_SetLoopMode					FSOUND_SetLoopMode;
	FSOUND_SetMute						FSOUND_SetMute;
	FSOUND_SetPan						FSOUND_SetPan;
	FSOUND_SetPaused						FSOUND_SetPaused;
	FSOUND_SetPriority					FSOUND_SetPriority;
	FSOUND_SetReserved					FSOUND_SetReserved;
	FSOUND_SetSurround					FSOUND_SetSurround;
	FSOUND_SetVolume						FSOUND_SetVolume;
	FSOUND_SetVolumeAbsolute				FSOUND_SetVolumeAbsolute;
	FSOUND_GetVolume						FSOUND_GetVolume;
	FSOUND_SetCurrentPosition				FSOUND_SetCurrentPosition;
	FSOUND_GetCurrentPosition				FSOUND_GetCurrentPosition;
	FSOUND_GetCurrentSample					FSOUND_GetCurrentSample;
	FSOUND_GetCurrentLevels					FSOUND_GetCurrentLevels;
	FSOUND_GetFrequency					FSOUND_GetFrequency;
	FSOUND_GetLoopMode					FSOUND_GetLoopMode;
	FSOUND_GetMixer						FSOUND_GetMixer;
	FSOUND_GetMute						FSOUND_GetMute;
	FSOUND_GetPan						FSOUND_GetPan;
	FSOUND_GetPaused						FSOUND_GetPaused;
	FSOUND_GetPriority					FSOUND_GetPriority;
	FSOUND_GetReserved					FSOUND_GetReserved;
	FSOUND_GetSurround					FSOUND_GetSurround;
	FSOUND_IsPlaying						FSOUND_IsPlaying;
	FSOUND_3D_Listener_GetAttributes			FSOUND_3D_Listener_GetAttributes;
	FSOUND_3D_Listener_SetAttributes			FSOUND_3D_Listener_SetAttributes;
	FSOUND_3D_GetAttributes					FSOUND_3D_GetAttributes;
	FSOUND_3D_Listener_SetCurrent				FSOUND_3D_Listener_SetCurrent;
	FSOUND_3D_SetDistanceFactor				FSOUND_3D_SetDistanceFactor;
	FSOUND_3D_SetDopplerFactor				FSOUND_3D_SetDopplerFactor;
	FSOUND_3D_SetRolloffFactor				FSOUND_3D_SetRolloffFactor;
	FSOUND_3D_SetAttributes					FSOUND_3D_SetAttributes;
	FSOUND_Update						FSOUND_Update;
	FSOUND_Stream_AddSynchPoint				FSOUND_Stream_AddSynchPoint;
	FSOUND_Stream_Close					FSOUND_Stream_Close;
	FSOUND_Stream_Create					FSOUND_Stream_Create;
	FSOUND_Stream_CreateDSP					FSOUND_Stream_CreateDSP;
	FSOUND_Stream_DeleteSynchPoint			FSOUND_Stream_DeleteSynchPoint;
	FSOUND_Stream_GetLength					FSOUND_Stream_GetLength;
	FSOUND_Stream_GetLengthMs				FSOUND_Stream_GetLengthMs;
	FSOUND_Stream_GetNumSubStreams			FSOUND_Stream_GetNumSubStreams;
	FSOUND_Stream_GetNumSynchPoints			FSOUND_Stream_GetNumSynchPoints;
	FSOUND_Stream_GetOpenState				FSOUND_Stream_GetOpenState;
	FSOUND_Stream_GetPosition				FSOUND_Stream_GetPosition;
	FSOUND_Stream_GetSample					FSOUND_Stream_GetSample;
	FSOUND_Stream_GetTime					FSOUND_Stream_GetTime;
	FSOUND_Stream_Open					FSOUND_Stream_Open;
	FSOUND_Stream_Play					FSOUND_Stream_Play;
	FSOUND_Stream_PlayEx					FSOUND_Stream_PlayEx;
	FSOUND_Stream_SetBufferSize				FSOUND_Stream_SetBufferSize;
	FSOUND_Stream_SetEndCallback				FSOUND_Stream_SetEndCallback;
	FSOUND_Stream_SetLoopPoints				FSOUND_Stream_SetLoopPoints;
	FSOUND_Stream_SetPosition				FSOUND_Stream_SetPosition;
	FSOUND_Stream_SetSubStream				FSOUND_Stream_SetSubStream;
	FSOUND_Stream_SetSynchCallback			FSOUND_Stream_SetSynchCallback;
	FSOUND_Stream_SetTime					FSOUND_Stream_SetTime;
	FSOUND_Stream_Stop					FSOUND_Stream_Stop;
	FSOUND_CD_Eject						FSOUND_CD_Eject;
	FSOUND_CD_GetNumTracks					FSOUND_CD_GetNumTracks;
	FSOUND_CD_GetPaused					FSOUND_CD_GetPaused;
	FSOUND_CD_GetTrack					FSOUND_CD_GetTrack;
	FSOUND_CD_GetTrackLength				FSOUND_CD_GetTrackLength; 
	FSOUND_CD_GetTrackTime					FSOUND_CD_GetTrackTime;
	FSOUND_CD_Play						FSOUND_CD_Play;
	FSOUND_CD_SetPaused					FSOUND_CD_SetPaused;
	FSOUND_CD_SetPlayMode					FSOUND_CD_SetPlayMode;
	FSOUND_CD_SetVolume					FSOUND_CD_SetVolume;
	FSOUND_CD_Stop						FSOUND_CD_Stop;
	FSOUND_DSP_ClearMixBuffer				FSOUND_DSP_ClearMixBuffer;
	FSOUND_DSP_Create						FSOUND_DSP_Create;
	FSOUND_DSP_Free						FSOUND_DSP_Free;
	FSOUND_DSP_SetActive					FSOUND_DSP_SetActive;
	FSOUND_DSP_GetActive					FSOUND_DSP_GetActive;
	FSOUND_DSP_GetBufferLength				FSOUND_DSP_GetBufferLength;
	FSOUND_DSP_GetBufferLengthTotal			FSOUND_DSP_GetBufferLengthTotal;
	FSOUND_DSP_SetPriority					FSOUND_DSP_SetPriority;
	FSOUND_DSP_GetPriority					FSOUND_DSP_GetPriority;
	FSOUND_DSP_GetClearUnit					FSOUND_DSP_GetClearUnit;
	FSOUND_DSP_GetClipAndCopyUnit				FSOUND_DSP_GetClipAndCopyUnit;
	FSOUND_DSP_GetMusicUnit					FSOUND_DSP_GetMusicUnit;
	FSOUND_DSP_GetSFXUnit					FSOUND_DSP_GetSFXUnit;
	FSOUND_DSP_GetFFTUnit					FSOUND_DSP_GetFFTUnit;
	FSOUND_DSP_GetSpectrum					FSOUND_DSP_GetSpectrum;
	FSOUND_DSP_MixBuffers					FSOUND_DSP_MixBuffers;
	FSOUND_FX_Disable						FSOUND_FX_Disable;    
	FSOUND_FX_Enable						FSOUND_FX_Enable;
	FSOUND_FX_SetChorus					FSOUND_FX_SetChorus;
	FSOUND_FX_SetCompressor					FSOUND_FX_SetCompressor;
	FSOUND_FX_SetDistortion					FSOUND_FX_SetDistortion;
	FSOUND_FX_SetEcho						FSOUND_FX_SetEcho;
	FSOUND_FX_SetFlanger					FSOUND_FX_SetFlanger;
	FSOUND_FX_SetGargle					FSOUND_FX_SetGargle;
	FSOUND_FX_SetI3DL2Reverb				FSOUND_FX_SetI3DL2Reverb;
	FSOUND_FX_SetParamEQ					FSOUND_FX_SetParamEQ;
	FSOUND_FX_SetWavesReverb				FSOUND_FX_SetWavesReverb;  
	FSOUND_Record_GetDriver					FSOUND_Record_GetDriver;
	FSOUND_Record_GetDriverName				FSOUND_Record_GetDriverName;
	FSOUND_Record_GetNumDrivers				FSOUND_Record_GetNumDrivers;
	FSOUND_Record_GetPosition				FSOUND_Record_GetPosition;  
	FSOUND_Record_SetDriver					FSOUND_Record_SetDriver;
	FSOUND_Record_StartSample				FSOUND_Record_StartSample;
	FSOUND_Record_Stop					FSOUND_Record_Stop;
	FSOUND_Reverb_SetProperties				FSOUND_Reverb_SetProperties;
	FSOUND_Reverb_GetProperties				FSOUND_Reverb_GetProperties;
	FSOUND_Reverb_SetChannelProperties			FSOUND_Reverb_SetChannelProperties;
	FSOUND_Reverb_GetChannelProperties			FSOUND_Reverb_GetChannelProperties;
	FSOUND_File_SetCallbacks				FSOUND_File_SetCallbacks;
	FSOUND_GetCPUUsage					FSOUND_GetCPUUsage;
	FSOUND_GetDriverCaps					FSOUND_GetDriverCaps;
	FSOUND_GetError						FSOUND_GetError;
	FSOUND_GetMemoryStats					FSOUND_GetMemoryStats;
	FSOUND_GetNumHardwareChannels				FSOUND_GetNumHardwareChannels;
	FSOUND_GetSFXMasterVolume				FSOUND_GetSFXMasterVolume;
	FSOUND_GetVersion						FSOUND_GetVersion;
	FSOUND_SetMemorySystem					FSOUND_SetMemorySystem;
	FSOUND_SetPanSeperation					FSOUND_SetPanSeperation;
	FSOUND_SetSFXMasterVolume				FSOUND_SetSFXMasterVolume;
	FSOUND_SetSpeakerMode					FSOUND_SetSpeakerMode;

	//FSOUND_Stream_Net_GetBufferProperties		FSOUND_Stream_Net_GetBufferProperties;
	//FSOUND_Stream_Net_GetInfo				FSOUND_Stream_Net_GetInfo;
	//FSOUND_Stream_Net_GetLastServerStatus		FSOUND_Stream_Net_GetLastServerStatus;
	//FSOUND_Stream_Net_SetBufferProperties		FSOUND_Stream_Net_SetBufferProperties;
	//FSOUND_Stream_Net_SetProxy				FSOUND_Stream_Net_SetProxy;
} fmodstruct;